// -------------------------------------------------------------------------
//
// Copyright or © or Copr. CNRS, (November 16, 2004)
//
// This software is a library providing tool for bioinformatics.
//
// This software is governed by the CeCILL  license under French law and
// abiding by the rules of distribution of free software.  You can  use,
// modify and/ or redistribute the software under the terms of the CeCILL
// license as circulated by CEA, CNRS and INRIA at the following URL
// "http://www.cecill.info".
//
// As a counterpart to the access to the source code and  rights to copy,
// modify and redistribute granted by the license, users are provided only
// with a limited warranty  and the software's author,  the holder of the
// economic rights,  and the successive licensors  have only  limited
// liability.
//
// In this respect, the user's attention is drawn to the risks associated
// with loading,  using,  modifying and/or developing or reproducing the
// software by the user in light of its specific status of free software,
// that may mean  that it is complicated to manipulate,  and  that  also
// therefore means  that it is reserved for developers  and  experienced
// professionals having in-depth computer knowledge. Users are therefore
// encouraged to load and test the software's suitability as regards their
// requirements in conditions enabling the security of their systems and/or
// data to be ensured and,  more generally, to use and operate it in the
// same conditions as regards security.
//
// The fact that you are presently reading this means that you have had
// knowledge of the CeCILL license and that you accept its terms.
//
// -------------------------------------------------------------------------

package TreeEditor;

/**
 * <p>Titre : Tree Editor</p>
 * <p>Description : Baobab core classes.</p>
 * <p>Copyright : Copyright (c) Julien Dutheil</p>
 * <p>Soci�t� : </p>
 * @author Julien Dutheil
 * @version 1.0
 */

import gnu.jtools.utils.gui.GraphicsTools;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class AboutDialog
    extends JDialog
    implements ActionListener {

  public AboutDialog(MainInterface mi) {
    super(mi, true);
    setLocale(mi.getLocale());
    setTitle(Baobab.message.getString("MainInterface.HelpAbout"));
    this.setBackground(Color.white);
    contentPane = this.getContentPane();

    about = new JTextPane();
    about.setEditable(false);
    try {
      about.setPage(AboutDialog.class.getResource("About.html"));
    } catch(Exception e) {
      System.err.println("About.html file not found!!!");
    }
    contentPane.add(new JScrollPane(about), BorderLayout.CENTER);

    valid = new JButton(Baobab.message.getString("ok"));
    valid.addActionListener(this);
    valid.setPreferredSize(new Dimension(100, 30));
    contentPane.add(valid, BorderLayout.SOUTH);
    setSize(500,500);
    GraphicsTools.center(this);
  }

  public void actionPerformed(ActionEvent ev) {
    setVisible(false);
  }

  private JTextPane about;
  private JButton valid;
  private Container contentPane;
}
