package bio.dendogram.io;

/**
 * <p>Title: Dendogram</p>
 * <p>Description: Set of Tools for dealing with phylogenetic trees (dendograms).</p>
 * <p>Copyright: 2002</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

import gnu.jtools.utils.file.FileTools;
import java.io.*;
import java.util.*;
import bio.dendogram.*;
import bio.sequences.io.NEXUSTools;

public class NexusFormat
    extends AbstractOTree
    implements ITree {

  public Tree[] readTree(File inFile) throws IOException {
    ArrayList trees = new ArrayList();
    HashMap translation = null;
    NEXUSTools.NEXUSEnvironment[] environments = NEXUSTools.getEnvironments(
    NEXUSTools.getLines(inFile));
    for (int i = 0; i < environments.length; i++) {
      if (environments[i].getName().toUpperCase().equals("TREES")) { //Trees
        //Command analysis:
        for (int j = 0; j < environments[i].numberOfCommands(); j++) {
          NEXUSTools.NEXUSCommand command = environments[i].getCommand(j);
           if (command.getName().toUpperCase().equals("TRANSLATE")) {
            //Leaves names
            translation = command;
          }
          if (command.getName().toUpperCase().equals("TREE")) {
            //Tree
            Tree tree = new Tree();
            tree.setRootNode(TreeTools.parenthesisToNode(tree,
                command.get(command.keySet().toArray()[0]).toString()));
            TreeTools.translateNames(tree, translation);
            trees.add(tree);
          }
        }
      }
    }
    return (Tree[]) trees.toArray(new Tree[0]);
  }

  public void writeTree(Tree tree, PrintWriter pw) throws IOException {
    System.out.println("Not implemented yet :-(");
  }

  public static javax.swing.filechooser.FileFilter NEXUS_FILTER = new javax.
      swing.filechooser.FileFilter() {

    public boolean accept(File file) {
      if (file.isDirectory()) {
        return true;
      }
      String extension = FileTools.getExtension(file);
      if (extension != null) {
        if (extension.equals("tre") ||
            extension.equals("trees") ||
            extension.equals("nex")) {
          return true;
        }
        else {
          return false;
        }
      }
      return false;
    }

    // The description of this filter
    public String getDescription() {
      return "Nexus tree files (*.tre, *.trees, *.nex)";
    }
  };

}
