package bio.dendogram.statistics;

/**
 * <p>Title: Bio</p>
 * <p>Description: Tools for bioinformatics</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Julien Dutheil
 * @version 1.0
 */

/* Date: Saturday August 21st, 2004*/
import bio.dendogram.*;

public class PhylogeneticRegression {

  /**
   * Set an arbitrary length to all branches.
   *
   * See Grafen 1989
   *
   * @param node Node
   * @return int The number assigned to the given node.
   */
  public static double computeBranchLengths(Node node, double power, double scale) {
    if(node.isLeaf()) return 0;
    double numberForThisNode = Math.pow(((double)(TreeTools.getNumberOfLeaves(node) - 1))/scale, power);
    for(int i = 0; i < node.getNumberOfSons(); i++) {
      node.getSon(i).setLength(numberForThisNode - computeBranchLengths(node.getSon(i), power, scale));
    }
    return numberForThisNode;
  }
}
