// -------------------------------------------------------------------------
//
// Copyright or © or Copr. CNRS, (November 16, 2004)
//
// This software is a library providing tool for bioinformatics.
//
// This software is governed by the CeCILL  license under French law and
// abiding by the rules of distribution of free software.  You can  use,
// modify and/ or redistribute the software under the terms of the CeCILL
// license as circulated by CEA, CNRS and INRIA at the following URL
// "http://www.cecill.info".
//
// As a counterpart to the access to the source code and  rights to copy,
// modify and redistribute granted by the license, users are provided only
// with a limited warranty  and the software's author,  the holder of the
// economic rights,  and the successive licensors  have only  limited
// liability.
//
// In this respect, the user's attention is drawn to the risks associated
// with loading,  using,  modifying and/or developing or reproducing the
// software by the user in light of its specific status of free software,
// that may mean  that it is complicated to manipulate,  and  that  also
// therefore means  that it is reserved for developers  and  experienced
// professionals having in-depth computer knowledge. Users are therefore
// encouraged to load and test the software's suitability as regards their
// requirements in conditions enabling the security of their systems and/or
// data to be ensured and,  more generally, to use and operate it in the
// same conditions as regards security.
//
// The fact that you are presently reading this means that you have had
// knowledge of the CeCILL license and that you accept its terms.
//
// -------------------------------------------------------------------------

package bio.dendogram.xml;

/**
 * <p>Title: Dendogram</p>
 * <p>Description: Set of Tools for dealing with phylogenetic trees (dendograms).</p>
 * <p>Copyright: 2002</p>
 * <p>Company: </p>
 * @author non attribu�
 * @version 1.0
 */

import bio.dendogram.*;

public class XTree extends Tree {
  /**
   * XTree stands for eXtensible Tree
   */

  /**
   * Constructors:
   */

  public XTree() { super(); }
  public XTree(String name) { super(name); }
  public XTree(String name, XNode root) { super(name, root); }
  public XTree(XNode root) { super(root); }
  public XTree(Tree tree) { super(tree); }

  public Object clone() {
    //WARNING!!! This method clones all internal nodes too.
    Tree result = new XTree((XNode)cloneSubtree(root));
    result.setName(name);
    return result;
  }

  public Node createNode() { return new XNode(super.createNode()); }
  public Node createNode(String nodeName, boolean checkName) throws NodeException {
    return new XNode(super.createNode(nodeName, checkName));
  }
  public Node createNode(Node node) {
    Node newNode = new XNode(node);
    newNode.setId(++nextId);
    return newNode;
  }

  /**
   * Attributes:
   */


}
