package bio.sequences;

/**
 * <p>Title: Bio</p>
 * <p>Description: Tools for bioinformatics</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Julien Dutheil
 * @version 1.0
 */

public class BadCharException extends AlphabetException {

  protected String c;

  /**
   * @brief Build a new BadCharException.
   * @param badChar The faulty character.
   * @param text A message to be passed to the exception hierarchy.
   * @param alpha A const pointer toward the alphabet that threw the exception.
   */
  public BadCharException(String badChar, String text, Alphabet alpha) {
    super("BadCharException: " + badChar + ". " + text, alpha);
    c = badChar;
  }

  /**
   * @brief Get the character that threw the exception.
   * @return the faulty character.
   */
  String getBadChar() { return c; }

}