package bio.sequences;

/**
 * <p>Title: Bio</p>
 * <p>Description: Tools for bioinformatics</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Julien Dutheil
 * @version 1.0
 */

public class BadIntException extends AlphabetException {

  protected int i;

  /**
   * @brief Build a new BadIntException.
   * @param badInt The faulty character.
   * @param text A message to be passed to the exception hierarchy.
   * @param alpha A const pointer toward the alphabet that threw the exception.
   */
  public BadIntException(int badInt, String text, Alphabet alpha) {
    super("BadIntException: " + badInt + ". " + text, alpha);
    i = badInt;
  }

  /**
   * @brief Get the character that threw the exception.
   * @return the faulty character.
   */
  int getBadInt() { return i; }
}