package bio.sequences;

/**
 * <p>Title: Bio</p>
 * <p>Description: Tools for bioinformatics</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Julien Dutheil
 * @version 1.0
 */

/**
 * @brief The DefaultAlphabet class.
 *
 * This alphabet should match virtually any type of sequences.
 * This should be used by who does not care of the sequence type.
 */
public class DefaultAlphabet
    extends AbstractAlphabet {

  protected String chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890?";

  public DefaultAlphabet() {
    // Alphabet size definition
    alphabet = new sletter[chars.length() + 1];

    // Alphabet content definition
    alphabet[0] = new sletter();
    alphabet[0].num = -1;
    alphabet[0].letter = "-";
    alphabet[0].abbr = "GAP";
    alphabet[0].name = "Gap";

    for (int i = 0; i < chars.length(); i++) {
      alphabet[i + 1] = new sletter();
      alphabet[i + 1].num = i;
      alphabet[i + 1].letter = "" + chars.charAt(i);
      alphabet[i + 1].abbr = "";
      alphabet[i + 1].name = "";
    }
  }

  public int getSize() {
    return chars.length();
  }

  public int getNumberOfTypes() {
    return chars.length();
  }

  public String getAlphabetType() {
    return "Default alphabet";
  }
}
