package bio.sequences;

/**
 * <p>Title: Bio</p>
 * <p>Description: Tools for bioinformatics</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Julien Dutheil
 * @version 1.0
 */

public class SequenceException extends Exception {

  /**
   * @brief A sequence object.
   */
  protected Sequence sequence;

  /**
   * @brief Build a new SequenceException object.
   *
   * @param text A message to be passed to the exception hierarchy.
   * @param seq A const pointer toward the sequence that threw the exception.
   */
  public SequenceException(String text, Sequence seq) {
    super(text);
    this.sequence = seq;
  }

  /**
   * @brief Get the sequence that threw the exception.
   *
   * @return A const pointer toward the sequence.
   */
 public Sequence getSequence() { return sequence; }
}
