// -------------------------------------------------------------------------
//
// Copyright or © or Copr. CNRS, (November 16, 2004)
//
// This software is a library providing tool for bioinformatics.
//
// This software is governed by the CeCILL  license under French law and
// abiding by the rules of distribution of free software.  You can  use,
// modify and/ or redistribute the software under the terms of the CeCILL
// license as circulated by CEA, CNRS and INRIA at the following URL
// "http://www.cecill.info".
//
// As a counterpart to the access to the source code and  rights to copy,
// modify and redistribute granted by the license, users are provided only
// with a limited warranty  and the software's author,  the holder of the
// economic rights,  and the successive licensors  have only  limited
// liability.
//
// In this respect, the user's attention is drawn to the risks associated
// with loading,  using,  modifying and/or developing or reproducing the
// software by the user in light of its specific status of free software,
// that may mean  that it is complicated to manipulate,  and  that  also
// therefore means  that it is reserved for developers  and  experienced
// professionals having in-depth computer knowledge. Users are therefore
// encouraged to load and test the software's suitability as regards their
// requirements in conditions enabling the security of their systems and/or
// data to be ensured and,  more generally, to use and operate it in the
// same conditions as regards security.
//
// The fact that you are presently reading this means that you have had
// knowledge of the CeCILL license and that you accept its terms.
//
// -------------------------------------------------------------------------

/**
 * Titre : Tree Editor<p>
 * Description : Permet l'�dition d'un arbre au format dnd
 * sous forme d'un fichier texte pour etre
 * plus facilement modifiable, puis de le reconvertir.<p>
 * Copyright : Copyright (c) Julien Dutheil<p>
 * @author Julien Dutheil
 * @version 1.0
 */
package bio.sequences;

/**
 * @brief The sequence not found exception base class.
 *
 * @see Exception
 */
public class SequenceNotFoundException extends Exception {

  /**
   * @brief The id of the sequence that was to be found.
   */
  protected String id;

  /**
   * @brief Build a new SequenceNotFoundException object.
   *
   * @param text A message to be passed to the exception hierarchy.
   * @param id   A the id of the sequence that was to be found.
   */
  public SequenceNotFoundException(String text, String seqId) {
    super(text);
    id = new String(seqId);
  }

  /**
   * @brief Get the id of the sequence that was to be found.
   *
   * @return The id of the sequence that was to be found.
   */
  public String getSequenceId() { return id; }

};
