package bio.sequences;

/**
 * <p>Title: Bio</p>
 * <p>Description: Tools for bioinformatics</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Julien Dutheil
 * @version 1.0
 */

public class SiteException extends Exception {

  /**
   * @brief A pointer toward a site object.
   */
  protected Site _site;

  /**
   * @brief Build a new SiteException object.
   *
   * @param text A message to be passed to the exception hierarchy.
   * @param s    A const pointer toward the site that threw the exception.
   */
  public SiteException(String text, Site s) {
    super(text);
    _site = s;
  }

  /**
   * @brief Get the site that threw the exception.
   *
   * @return A const pointer toward the site.
   */
  public Site getSite() {
    return _site;
  }

}
