package bio.sequences.io;

/**
 * <p>Title: Bio</p>
 * <p>Description: Tools for bioinformatics</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Julien Dutheil
 * @version 1.0
 */

import bio.sequences.*;
import java.io.*;

/**
 * @brief The ISequence interface.
 */
public interface ISequence extends IOSequence {

  /**
   * @brief Create a new container from a file.
   *
   * @param file  The file to read.
   * @param alpha The alphabet to be associated to the container.
   * @throw Exception If the file is not in the specified format.
   */
  public VectorSequenceContainer read(File file, Alphabet alpha) throws Exception;

  /**
   * @brief Add sequences to a container from a file.
   *
   * @param file  The file to read.
   * @param alpha The alphabet to be associated to the container.
   * @throw Exception If the file is not in the specified format.
   */
  public void read(File file, VectorSequenceContainer sc) throws Exception;
}
