/*
 * StatsTools package. You should have received this file along with another program.
 * See the program files for description and full license terms.
 * Copyright (C) 2003  Julien Dutheil
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package gnu.jtools.stats.graphe;

import gnu.jtools.stats.StatTools;
import gnu.jtools.stats.array.ArrayStatTools;
import gnu.jtools.utils.gui.Range;

import javax.swing.*;
import java.awt.*;

/**
 * WARNING: not fully implemented yet!
 */

public class Histogram extends JPanel {

  public Histogram(String title, double[] x, int nbClasses, String[] xnames) {
    this.title = title;
    this.data = x;
    this.breaks = ArrayStatTools.getBreaks(x, nbClasses);
    double[][] decomposition = ArrayStatTools.decompose(x, breaks);
    this.counts = ArrayStatTools.getCounts(decomposition);
    this.probabilities = ArrayStatTools.getProbabilities(counts);
    this.mids = ArrayStatTools.getMids(breaks);
    this.xnames = xnames;
    fen = new Range(0, counts.length + 1, 0, ArrayStatTools.max(counts));
    setSize(400, 200);
    setBackground(Color.white);
  }

  public void setSize(int width, int height) {
    super.setSize(width, height);
    fen.setWidth(width-10);
    fen.setLength(height-100);
  }
  public void setSize(Dimension d) {
    super.setSize(d);
    fen.setWidth((int)d.getWidth()-10);
    fen.setLength((int)d.getHeight()-100);
  }

  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    g.setFont(new Font("SansSerif",Font.PLAIN,10));
    fm = g.getFontMetrics();
    int h = fm.getHeight();
      g.setColor(Color.blue);
      g.drawString(title, 2, h);
      g.drawString("Mean = " + ArrayStatTools.mean(data), 2, 2*h);
      g.drawString("Min  = " + ArrayStatTools.min(data), 2, 3*h);
      g.drawString("Max  = " + ArrayStatTools.max(data), 2, 4*h);
    for(int i = 0; i < counts.length; i++) {
      if(counts[i] != 0) {
        g.setColor(Color.red);
        g.fillRect(fen.x(i), fen.y(counts[i]) + 5 * h, fen.x(1), fen.y(0) - fen.y(counts[i]));
        g.setColor(Color.black);
        g.drawRect(fen.x(i), fen.y(counts[i]) + 5 * h, fen.x(1), fen.y(0) - fen.y(counts[i]));
        g.drawString(xnames[i], fen.x(i) + 2, fen.y(counts[i]) + 2 * h - 1);
        g.drawString("" + StatTools.round(mids[i], 2), fen.x(i) + 2, fen.y(counts[i]) + 3 * h - 1);
        g.drawString("" + counts[i], fen.x(i) + 2, fen.y(counts[i]) + 4 * h - 1);
        g.drawString((int)(counts[i] * 100 / ArrayStatTools.sum(counts)) + "%", fen.x(i) + 2, fen.y(counts[i]) + 5 * h - 1);
      }
    }
  }

  public double[] getBreaks()        { return breaks;        }
  public double[] getProbabilities() { return probabilities; }
  public double[] getMids()          { return mids;          }

  private String title;
  private double[] data, breaks, probabilities, mids;
  private int[] counts;
  private String[] xnames;
  private FontMetrics fm;
  private Range fen;
}