package gnu.jtools.stats.gui;

/**
 * <p>Title: Stats</p>
 * <p>Description: Statistics tools</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Julien Dutheil
 * @version 1.0
 */

import gnu.jtools.stats.table.Table;
import javax.swing.table.*;
import javax.swing.event.*;
import java.util.*;

public class SpreadSheetTableModel
    extends AbstractTableModel {

  protected Table table;

  public SpreadSheetTableModel(Table table) {
    this.table = table;
  }

  public int getColumnCount() {
    return table.getNumberOfColumns() + 1;
  }

  public int getRowCount() {
    return table.getNumberOfRows();
  }

  public boolean isCellEditable(int rowIndex, int columnIndex) {
    return columnIndex > 0;
  }

  public Class getColumnClass(int columnIndex) {
    return columnIndex == 0 ? String.class : table.getColumnClass(columnIndex - 1);
  }

  public Object getValueAt(int rowIndex, int columnIndex) {
    return columnIndex == 0 ? table.getRowName(rowIndex) : table.getCell(rowIndex, columnIndex - 1);
  }

  public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
    if(columnIndex == 0) table.setRowName(rowIndex, (String)aValue);
    else table.setCell(rowIndex, columnIndex - 1, aValue);
    this.fireTableChanged(new TableModelEvent(this, rowIndex, rowIndex, columnIndex));
  }

  public String getColumnName(int columnIndex) {
    return columnIndex == 0 ? "Node names" : table.getColumnName(columnIndex - 1);
  }

}
