/*
 * StatsTools package. You should have received this file along with another program.
 * See the program files for description and full license terms.
 * Copyright (C) 2003  Julien Dutheil
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package gnu.jtools.stats.list;

import gnu.jtools.stats.RandomTools;
import java.util.*;

public class ListOperators {

  public static int[] toArrayOfInt(List l) {
    Integer[] entiers=(Integer[])(l.toArray(new Integer[0]));
    int[] result=new int[entiers.length];
    for(int i=0; i<result.length; i++) {
      result[i]=entiers[i].intValue();
      }
    return result;
    }
  public static double[] toArrayOfDouble(List l) {
    Double[] doubles=(Double[])(l.toArray(new Double[0]));
    double[] result=new double[doubles.length];
    for(int i=0; i<result.length; i++) {
      result[i]=doubles[i].doubleValue();
      }
    return result;
    }

  public static int indexOfRef(List list, Object object) {
    int result=-1;
    for(int i=0; i<list.size(); i++) {
      if(list.get(i)==object) result=i;//l'objet est contenu dans le tableau.
    }
    return result;
  }

  /****************************************************************************/

  /**
   * This shuffle the elements in a list.
   *
   * This method make a copy of the list, clear it and then randomly re-add each
   * backed up element to the list.
   *
   * @param list The list to shuffle.
   */
  public static void shuffle(List list) {
    ArrayList copy = new ArrayList(list);
    while(copy.size() > 0) {
      list.add(copy.remove(RandomTools.randomInt(copy.size())));
    }
  }

}
