/*
 * StatsTools package. You should have received this file along with another program.
 * See the program files for description and full license terms.
 * Copyright (C) 2003  Julien Dutheil
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package gnu.jtools.stats.list;

import java.util.*;

public class ListStatTools {

  public static Class getClass(List l) {
    Iterator i = l.iterator();
    Class c = i.next().getClass();
    while(i.hasNext()) if(i.next().getClass() != c) throw new NumberFormatException();
    return c;
  }

  public static double sum(List l) {
    double result = 0;
    for(int i = 0; i < l.size(); i++) {
      result += ((Number)(l.get(i))).doubleValue();
    }
    return result;
  }

  public static double mean(List l) {
    double result = sum(l)/l.size();
    return result;
  }

  public static List sqr(List l) {
    ArrayList result = new ArrayList(l.size());
    for(int i = 0; i < l.size(); i++) {
      result.add(new Double(Math.pow(((Number)l.get(i)).doubleValue(), 2)));
    }
    return result;
  }

  public static double variance(List l) {//sample variance
    return mean(sqr(l)) - Math.pow(mean(l), 2);
  }

  public static double min(List l) {
    double result = Double.POSITIVE_INFINITY;
    double x;
    for(int i = 0; i < l.size(); i++) {
      x =  ((Number)l.get(i)).doubleValue();
      if(x < result) result = x;
    }
    return result;
  }

  public static double max(List l) {
    double result = Double.NEGATIVE_INFINITY;
    double x;
    for(int i = 0; i < l.size(); i++) {
      x = ((Number)l.get(i)).doubleValue();
      if(x > result) result=x;
    }
    return result;
  }


/*  public static int[] decompose(List l, int nbFreq) {
    double mini = min(l);
    double maxi = max(l);
    double x;
    int indice;
    int[] result = new int[nbFreq-1];
    for(int i = 0; i < l.size(); i++) {
      x = ((Number)l.get(i)).doubleValue();
      indice = (int)((x-mini)/(maxi-mini)*nbFreq);
      if(indice == nbFreq) result[indice-1]++;
      else result[indice]++;
    }
    return result;
  }*/
}
