package gnu.jtools.stats.table;

/**
 * <p>Title: Stats</p>
 * <p>Description: Statistics tools</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Julien Dutheil
 * @version 1.0
 */

public class InvalidTableRowSizeException extends TableException {

  public InvalidTableRowSizeException(Table t, int badSize) {
    super(t);
    this.rowSize = badSize;
  }

  public InvalidTableRowSizeException(String p0, Table t, int badSize) {
    super(p0, t);
    this.rowSize = badSize;
  }

  public InvalidTableRowSizeException(String p0, Throwable p1, Table t, int badSize) {
    super(p0, p1, t);
    this.rowSize = badSize;
  }

  public InvalidTableRowSizeException(Throwable p0, Table t, int badSize) {
    super(p0, t);
    this.rowSize = badSize;
  }

  /**
   * Get the size of the row that did not match the table size.
   *
   * @return The size of the invalid row.
   */
  public int getRowSize() { return rowSize; }

  protected int rowSize;
}