package gnu.jtools.stats.table;

/**
 * <p>Title: Stats</p>
 * <p>Description: Statistics tools</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Julien Dutheil
 * @version 1.0
 */

public class TableColumnNotFoundException extends TableException {

  public TableColumnNotFoundException(Table t, String name) {
    super(t);
    this.columnName = name;
  }

  public TableColumnNotFoundException(String p0, Table t, String name) {
    super(p0, t);
    this.columnName = name;
  }

  public TableColumnNotFoundException(String p0, Throwable p1, Table t, String name) {
    super(p0, p1, t);
    this.columnName = name;
  }

  public TableColumnNotFoundException(Throwable p0, Table t, String name) {
    super(p0, t);
    this.columnName = name;
  }

  /**
   * Get the name of the column that could not be found.
   *
   * @return The name of the column not found.
   */
  public String getColumnName() { return columnName; }

  protected String columnName;
}