
/**
 * Titre : Graphic Window<p>
 * Description : Package contenant des classes de graphisme
 * (Definition d'un repere, trace de points, de droites, de fonctions...).<p>
 * Copyright : Copyright (c) DUTHEIL Julien<p>
 * @author DUTHEIL Julien
 * @version 1.0
 */
package gnu.jtools.utils.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ZoomControls {

  public ZoomControls(JComponent c , JScrollPane container) {
    this.c = c;
    this.o = container;
    //Default settings:
    widthCoef = 1.25;
    heightCoef = 1.25;
    widthCte = 0;
    heightCte = 0;
    initActions();
  }

  public void setCoefs(double widthCoef, double heightCoef) {
    this.widthCoef = widthCoef;
    this.heightCoef = heightCoef;
  }
  public void setCtes(int widthCte, int heightCte) {
    this.widthCte = widthCte;
    this.heightCte = heightCte;
  }

  public double[] getCoefs() {
    double[] coefs = new double[2];
    coefs[0] = widthCoef;
    coefs[1] = heightCoef;
    return coefs;
  }
  public int[] getCtes() {
    int[] ctes = new int[2];
    ctes[0] = widthCte;
    ctes[1] = heightCte;
    return ctes;
  }

  private void initActions() {


    zoomPlus = new AbstractAction("Zoom +") {
      public void actionPerformed(ActionEvent e) {
        Dimension d = c.getPreferredSize();
        c.setPreferredSize(new Dimension(
          new Double((d.width - widthCte )   / widthCoef ).intValue(),
          new Double((d.height - heightCte ) / heightCoef).intValue()));
        o.getViewport().revalidate();
      }
    };

    zoomMinus = new AbstractAction("Zoom -") {
      public void actionPerformed(ActionEvent e) {
        Dimension d = c.getPreferredSize();
        c.setPreferredSize(new Dimension(
          new Double(d.width * widthCoef).intValue()  + widthCte,
          new Double(d.height * heightCoef).intValue() + heightCte ));
      o.getViewport().revalidate();
      }
    };

    zoomWidthPlus = new AbstractAction("Zoom width +", new ImageIcon(getClass().getResource("ZoomWidthPlus.gif"))) {
      public void actionPerformed(ActionEvent e) {
        Dimension d = c.getPreferredSize();
        c.setPreferredSize(new Dimension(
            new Double(d.width * widthCoef).intValue() + widthCte,
            d.height));
        o.getViewport().revalidate();
      }
    };

    zoomWidthMinus = new AbstractAction("Zoom Width -", new ImageIcon(getClass().getResource("ZoomWidthMinus.gif"))) {
      public void actionPerformed(ActionEvent e) {
        Dimension d = c.getPreferredSize();
        c.setPreferredSize(new Dimension(
          new Double((d.width - widthCte )   / widthCoef ).intValue(),
          d.height));
      o.getViewport().revalidate();
      }
    };

    zoomHeightPlus = new AbstractAction("Zoom Height +", new ImageIcon(getClass().getResource("ZoomHeightPlus.gif"))) {
      public void actionPerformed(ActionEvent e) {
        Dimension d = c.getPreferredSize();
        c.setPreferredSize(new Dimension(
          d.width,
          new Double(d.height * heightCoef).intValue() + heightCte ));
      o.getViewport().revalidate();
      }
    };

    zoomHeightMinus = new AbstractAction("Zoom Height -", new ImageIcon(getClass().getResource("ZoomHeightMinus.gif"))) {
      public void actionPerformed(ActionEvent e) {
        Dimension d = c.getPreferredSize();
        c.setPreferredSize(new Dimension(
          d.width,
          new Double((d.height - heightCte ) / heightCoef).intValue()));
      o.getViewport().revalidate();
      }
    };
  }

  public Action getZoomPlus()        { return zoomPlus; }
  public Action getZoomMinus()       { return zoomMinus; }
  public Action getZoomWidthPlus()   { return zoomWidthPlus; }
  public Action getZoomWidthMinus()  { return zoomWidthMinus; }
  public Action getZoomHeightPlus()  { return zoomHeightPlus; }
  public Action getZoomHeightMinus() { return zoomHeightMinus; }

  private Action zoomPlus, zoomMinus, zoomWidthPlus, zoomWidthMinus, zoomHeightPlus, zoomHeightMinus;
  private JComponent c;
  private JScrollPane o;
  private double widthCoef, heightCoef;
  private int widthCte, heightCte;
}