package gnu.jtools.utils.storage;

/**
 * <p>Titre : StorageTools</p>
 * <p>Description : Storage Tools</p>
 * <p>Copyright : Copyright (c) </p>
 * @author Julien Dutheil
 * @version 1.0
 */

import java.util.*;

public abstract class AbstractReverseMap<Key, Value> extends AbstractMap<Key, Value> implements ReverseMap<Key, Value> {

  public Value getValue(Key key) {
    return super.get(key);
  }

  public Key getKey(Value value) {
      Iterator<Entry<Key,Value>> i = entrySet().iterator();
      if (value==null) {
          while (i.hasNext()) {
              Entry<Key,Value> e = i.next();
              if (e.getValue()==null)
                  return e.getKey();
          }
      } else {
          while (i.hasNext()) {
              Entry<Key, Value> e = i.next();
              if (value.equals(e.getValue()))
                  return e.getKey();
          }
      }
      return null;
  }

  public List<Key> getKeys(Value value) {
      Iterator<Entry<Key,Value>> i = entrySet().iterator();
      List<Key> result = new ArrayList<Key>();
      if (value==null) {
          while (i.hasNext()) {
              Entry<Key, Value> e = i.next();
              if (e.getValue()==null)
                  result.add(e.getKey());;
          }
      } else {
          while (i.hasNext()) {
              Entry<Key,Value> e = i.next();
              if (value.equals(e.getValue()))
                  result.add(e.getKey());
          }
      }
      return result;
  }
}