/*
 * StatsTools package. You should have received this file along with another program.
 * See the program files for description and full license terms.
 * Copyright (C) 2003  Julien Dutheil
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package gnu.jtools.utils.string;

import java.util.*;

public class StringOperators {

  public static String removeChar(String chain, char charac) {
    StringBuffer buffer=new StringBuffer(chain);
    for(int i=0; i<buffer.length(); i++) {
      if(buffer.charAt(i)==charac) {//Excision
        buffer.deleteCharAt(i);
        i--;
        }
      }
    return buffer.toString();
    }

  public static String getString(String unit, int rep) {
    StringBuffer result=new StringBuffer("");
    for(int i=0; i<rep; i++) { result.append(unit); }
    return result.toString();
  }

  public static String replaceAll(String aString, String pattern, String replacement) {
    if(aString == null || pattern == null || replacement == null) return aString;
    if(aString.equals("") || pattern.equals("") || replacement.equals("")) return aString;
    StringBuffer sb = new StringBuffer(aString);
    int pos = sb.indexOf(pattern);
    while(pos > -1) {
      //System.out.println("Replacing " + pattern + " by " + replacement + " at position " + pos + ".");
      sb.replace(pos, pos + pattern.length(), replacement);
      pos = sb.indexOf(pattern, pos + replacement.length());
    }
    return sb.toString();
  }

}
