package gnu.jtools.utils.xmltools;

/**
 * <p>Titre : XMLTools</p>
 * <p>Description : XML Tools</p>
 * <p>Copyright : Copyright (c) 2002</p>
 * @author Julien Dutheil
 * @version 1.0
 */

import java.io.*;

public class XMLDocument extends XMLElement {

  public XMLDocument(String name, String content) {
    super(name, content);
    docType = null;
    DTD = null;
    header = this.DEFAULT_HEADER;
  }
  public XMLDocument(String name, String content, String docType, String DTD) {
    super(name, content);
    this.docType = docType;
    this.DTD = DTD;
    header = this.DEFAULT_HEADER;
  }

  public void setDocType(String docType) { this.docType = docType; }
  public String getDocType() { return docType; }

  public void setDTD(String DTD) { this.DTD = DTD; }
  public String getDTD() { return DTD; }

  public void setHeader(String header) { this.header = header; }
  public String getHeader() { return header; }

  public void print(PrintWriter pw) {
    pw.println(header);
    if(docType != null && DTD != null) pw.println("<!DOCTYPE " + getDocType() + " SYSTEM \"" + getDTD() + "\">");
    if(hasChild()) {
      pw.print("<" + getTagName());
      if(attributes != null) {//Writes attributes:
        String[] keys = (String[])attributes.keySet().toArray(new String[0]);
        for(int i = 0; i < keys.length; i++) pw.print(" " + keys[i] + "=\"" + attributes.get(keys[i]).toString() + "\"");
      }
      pw.println(">");
      for(int i = 0; i < this.getChildren().size(); i++) {
        this.getChild(i).print(pw, indentation);
      }
      pw.println("</" + getTagName() + ">");
    } else {
      pw.print("<" + getTagName());
      if(attributes != null) {//Writes attributes:
        String[] keys = (String[])attributes.keySet().toArray(new String[0]);
        for(int i = 0; i < keys.length; i++) pw.print(" " + keys[i] + "=\"" + attributes.get(keys[i]).toString() + "\"");
      }
      pw.println(">");
      pw.println(element);
      pw.println("</" + getTagName() + ">");
    }
  }

  private String content, docType, DTD, header;
  public static final String DEFAULT_HEADER = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>";
}
